//скетч для передатчика с ключом key4 (308000)
#include <avr/power.h>
#include <avr/sleep.h>
#include <avr/wdt.h>
#include <RCSwitch.h>
#include <OneWire.h>
//#include <LowPower.h>
#include <DHT.h>

RCSwitch mySwitch = RCSwitch();

//float tempout=-25.48;
//float tempin=30.64;

#define key1  300000   //влажность1
#define key2  303000  //температура1
#define key3  305000 // датчик влажность2
#define key4  308000 // датчик температуры2

#define ACCESSORIESPOWERPIN 3
#define TRANSMITPOWEREN 11
#define DHTPIN 4
#define DHTTYPE DHT22
#define TCORRECTION (0)
#define HCORRECTION (0)
#define SLEEPDURATION 1280  //640sleep duration in seconds, shall be a factor of 8

DHT dht(DHTPIN, DHTTYPE);
//DS18b20
OneWire ds(5);
byte i;
byte present = 0;
byte type_s;
byte data[12];
byte addr[8];
float celsius;

void sleepFor8Secs()
{
  // disable ADC
  byte old_ADCSRA = ADCSRA;
  ADCSRA = 0;

  // turn off various modules
  byte old_PRR = PRR;
  PRR = 0xFF;

  // clear various "reset" flags
  MCUSR = 0;
  // allow changes, disable reset
  WDTCSR = bit (WDCE) | bit (WDE);
  // set interrupt mode and an interval
  WDTCSR = bit (WDIE) | bit (WDP3) | bit (WDP0);    // set WDIE, and 8 seconds delay
  wdt_reset();  // pat the dog

  set_sleep_mode (SLEEP_MODE_PWR_DOWN);
  sleep_enable();

  // turn off brown-out enable in software
  MCUCR = bit (BODS) | bit (BODSE);
  MCUCR = bit (BODS);
  sleep_cpu ();

  // cancel sleep as a precaution
  sleep_disable();
  PRR = old_PRR;
  ADCSRA = old_ADCSRA;
}

// watchdog interrupt
ISR (WDT_vect)
{
  wdt_disable();  // disable watchdog
}  // end of WDT_vect



void setup() {
  mySwitch.enableTransmit(10); // пин,на который подключен передатчик
  dht.begin();
  Serial.begin(9600);
  Serial.print("Transmitter");


  // Optional set pulse length.
  //mySwitch.setPulseLength(321);

  // set protocol (default is 1, will work for most outlets)
  // mySwitch.setProtocol(2);

  // Optional set number of transmission repetitions.
  // mySwitch.setRepeatTransmit(15);

  //clock_prescale_set (clock_div_2);
}


void loop() {


  pinMode(ACCESSORIESPOWERPIN, OUTPUT);
  digitalWrite(ACCESSORIESPOWERPIN, HIGH); //turn on the DHT sensor
 // delay(500); //sleep till the intermediate processes in the accessories are settled down

 // float humidity = dht.readHumidity() + HCORRECTION;
 // float temperature = dht.readTemperature() + TCORRECTION;

  if ( !ds.search(addr)) {
    // Serial.println("No more addresses.");
    // Serial.println();//
    ds.reset_search();
    delay(250);
    return;
  }

  // Serial.print("ROM =");
  //  for ( i = 0; i < 8; i++) {
  //   Serial.write(' ');
  //    Serial.print(addr[i], HEX);
  //  }

  //  if (OneWire::crc8(addr, 7) != addr[7]) {
  //    Serial.println("CRC is not valid!");
  //    return;
  //  }
  //  Serial.println();
  ds.reset();
  ds.select(addr);
  ds.write(0x44, 1);        // start conversion, with parasite power on at the end


  delay(1000);     // maybe 750ms is enough, maybe not
  // we might do a ds.depower() here, but the reset will take care of it.

  present = ds.reset();
  ds.select(addr);
  ds.write(0xBE);         // Read Scratchpad

  // Serial.print("  Data = ");
  // Serial.print(present, HEX);
  // Serial.print(" ");
  for ( i = 0; i < 9; i++) {           // we need 9 bytes
    data[i] = ds.read();
    //   Serial.print(data[i], HEX);
    //   Serial.print(" ");
  }
  // Serial.print(" CRC=");
  // Serial.print(OneWire::crc8(data, 8), HEX);
  // Serial.println();

  // Convert the data to actual temperature
  // because the result is a 16 bit signed integer, it should
  // be stored to an "int16_t" type, which is always 16 bits
  // even when compiled on a 32 bit processor.
  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) {
    raw = raw << 3; // 9 bit resolution default
    if (data[7] == 0x10) {
      // "count remain" gives full 12 bit resolution
      raw = (raw & 0xFFF0) + 12 - data[6];
    }
  } else {
    byte cfg = (data[4] & 0x60);
    // at lower res, the low bits are undefined, so let's zero them
    if (cfg == 0x00) raw = raw & ~7;  // 9 bit resolution, 93.75 ms
    else if (cfg == 0x20) raw = raw & ~3; // 10 bit res, 187.5 ms
    else if (cfg == 0x40) raw = raw & ~1; // 11 bit res, 375 ms
    //// default is 12 bit resolution, 750 ms conversion time
  }
  celsius = (float)raw / 16.0;


  digitalWrite(ACCESSORIESPOWERPIN, LOW); // turn off the accessories power
  pinMode(ACCESSORIESPOWERPIN, INPUT); //change pin mode to reduce power consumption
  pinMode(TRANSMITPOWEREN, OUTPUT);
  digitalWrite(TRANSMITPOWEREN, HIGH); //включаем передатчик
  delay(50);
  // sendRC(humidity * 10 + key1);
  // delay(1000);
  //sendRC(temperature * 10 + key2 + 500);
  //delay(1000);
  sendRC(celsius * 10 + key4 + 500);
  digitalWrite(TRANSMITPOWEREN, LOW); //выключаем передатчик
  pinMode(ACCESSORIESPOWERPIN, INPUT); //change pin mode to reduce power consumption
  //delay(1000);
  // Serial.print("Humidity: ");
  // Serial.println(humidity);
  // Serial.print("Temperature: ");
  // Serial.println(temperature);
  // Serial.print("Temperature_ds: ");
  // Serial.println(celsius);


  for (int i = 0; i < SLEEPDURATION / 8; i++)
    sleepFor8Secs();



}

// подпрограмма отправки данных
void sendRC(unsigned long code) {

  mySwitch.send(code, 20);

}


